Package org.apache.groovy.parser.antlr4.internal.atnmanager

## Class AtnManager

- java.lang.Object
- - org.apache.groovy.parser.antlr4.internal.atnmanager.AtnManager

- Direct Known Subclasses:
    `LexerAtnManager`, `ParserAtnManager`

      public abstract class AtnManager
      extends Object

  Manage ATN to avoid memory leak

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected class` | `AtnManager.AtnWrapper` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ReentrantReadWriteLock.ReadLock` | `READ_LOCK` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AtnManager()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract org.antlr.v4.runtime.atn.ATN` | `getATN()` |
    `protected abstract boolean` | `shouldClearDfaCache()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### READ_LOCK

          public static final ReentrantReadWriteLock.ReadLock READ_LOCK

  - ### Constructor Detail

    - #### AtnManager

          public AtnManager()

  - ### Method Detail

    - #### getATN

          public abstract org.antlr.v4.runtime.atn.ATN getATN()

    - #### shouldClearDfaCache

          protected abstract boolean shouldClearDfaCache()